﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text; 
using System.Threading;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.IO;

namespace KinectClient
{
    public partial class Form1 : Form
    {
        Thread thread = null;
        BodyPosture currentPosture;
        BodyPostures postures;

        public Form1()
        {
            InitializeComponent();

            pbSkeleton.Image = new Bitmap(pbSkeleton.Width, pbSkeleton.Height);


        }

        private void GetData()
        {

            postures = new BodyPostures();

            TcpClient client = new TcpClient();

            try
            {
                // client.Connect("127.0.0.1", 12345);
                string adresa = textServerIP.Text;
                int port = Convert.ToInt32(textPort.Text);
                client.Connect(adresa, port);

                while (1 == 1)
                {
                    try
                    {
                        NetworkStream stream = client.GetStream();
                        byte[] buffer = new byte[1024 * 1024];
                        int numBytesRead = stream.Read(buffer, 0, buffer.Length);
                        currentPosture = new BodyPosture(
                            System.Text.ASCIIEncoding.ASCII.GetString(
                            buffer, 0, numBytesRead)
                            );
                        UpdateBodyPosture(currentPosture);
                        Thread.Sleep(500);
                    }
                    catch (Exception exc)
                    {
                        Console.WriteLine(exc.ToString());
                    }
                }
            }
            catch(Exception exc)
            {
                Console.WriteLine(exc.ToString());
            }
           client.Close();
        }

        private delegate void UpdateBodyPostureDelegate(BodyPosture posture);
        private void UpdateBodyPosture(BodyPosture posture)
        {
            if (this.InvokeRequired)
            {
                this.Invoke(new UpdateBodyPostureDelegate(UpdateBodyPosture), new object[] { posture });
                return;
            }

            using(Bitmap bitmap = posture.ToBitmap(640, 480))
            using (Graphics graphics = Graphics.FromImage(pbSkeleton.Image))
            {
                graphics.DrawImage(bitmap, 0, 0);
                pbSkeleton.Refresh();
            }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (thread != null)
            {
                try
                {
                    thread.Abort();
                }
                catch { }
            }
        }

        private void savePostureButton_Click(object sender, EventArgs e)//functie rulata la apasarea butonul de salvare
        {
            postures.Add(currentPosture);
            postures.names.Add(nameTextBox.Text);
            postures.WriteToFile(nameTextBox.Text + ".txt");
        }

        private void readPostureButton_Click(object sender, EventArgs e)//functie rulata la apasarea butonul de citire
        {
            postures.Clear();
            postures.ReadAllPostures();
            postures.DisplayAllPostures();
            Console.WriteLine("{0} postures", postures.Count);
            Console.WriteLine(postures.Classify(postures[0]));
            Console.WriteLine(postures.Classify(postures[1]));
        }

        private void visualizePostureButton_Click(object sender, EventArgs e)//functie rulata la apasarea butonul de vizualizare
        {
            foreach(BodyPosture posture in postures)
            {
                UpdateBodyPosture(posture);
                Thread.Sleep(2000);
            }
        }

        private void buttonConnect_Click(object sender, EventArgs e)//functie rulata la apasarea butonul de conectare
        {
            thread = new Thread(new ThreadStart(GetData));
            thread.Start();
        }

        public static void KillCurrentThread()
        {
            Thread.CurrentThread.Abort();
        }
    }
}
